package com.jdbernard.timestamper

import java.awt.Color
import java.awt.Point
import java.awt.Rectangle
import java.awt.Toolkit
import javax.swing.BoxLayout
import javax.swing.JDialog
import com.jdbernard.GUIUtil
import net.miginfocom.swing.MigLayout

Point mousePressRelativeToDialog
Point offsetFromMainFrame = new Point(0,0)
boolean coupledToMainFrame = false

mousePressed = { evt -> mousePressRelativeToDialog = evt?.point }

mouseDragged = { evt ->
    GUIUtil.componentDragged(dialog, evt, mousePressRelativeToDialog,
    new Rectangle(Toolkit.defaultToolkit.screenSize),
    model.mainMVC.view.frame.bounds)

    offsetFromMainFrame = GUIUtil.calculateOffset(
        model.mainMVC.view.frame, dialog)

    coupledToMainFrame = GUIUtil.componentsCoupled(dialog,
        model.mainMVC.view.frame);
        
}

dialog = dialog(new JDialog(model.mainMVC.view.frame),
    title: 'Notes',
    modal: false,
    undecorated: true,
    minimumSize: [325, 200],
    mousePressed: mousePressed,
    mouseDragged: mouseDragged,
    iconImage: imageIcon('/16-em-pencil.png').image,
    iconImages: [imageIcon('/16-em-pencil.png').image],
    location: bind(source: model.mainMVC.model,
        sourceProperty: 'absoluteLocation',
        converter: { loc ->
            if (coupledToMainFrame) {
                Point p = new Point(offsetFromMainFrame)
                p.translate((int) loc.x, (int) loc.y)
                return p
            } else return dialog.location })
) {
    logger.traceIfEnabled('Building NotesDialog GUI')
    panel(
      border:lineBorder(color: Color.BLACK, thickness:1, parent:true),
      layout: new MigLayout('insets 10 10 10 10, fill')
    ) {
        scrollPane(constraints: 'growx, growy') {
            notesTextArea = textArea(lineWrap: true, columns: 20, rows: 5,
                wrapStyleWord: true,
                text: bind(source: model.mainMVC.model,
                    sourceProperty: 'currentMarker',
                    sourceValue: { model.mainMVC.model.currentMarker?.notes}),
                keyReleased: {
                    if (model.mainMVC.model.currentMarker != null)
                        model.mainMVC.model.currentMarker.notes =
                            notesTextArea.text})
        }
    }
}
