package com.jdbernard.timestamper.core;

import java.io.File;
import java.net.URI;

/**
 *
 * @author Jonathan Bernard ({@literal jonathan.bernard@gemalto.com})
 */
public class TimelineSourceFactory {

    public static TimelineSource newInstance(URI uri) {
        // File based
        if ("file".equalsIgnoreCase(uri.getScheme())) {
            return new FileTimelineSource(uri);
        }

        // Twitter
        else if ("http".equalsIgnoreCase(uri.getScheme()) &&
                    ("twitter.com".equalsIgnoreCase(uri.getHost())
                  || "www.twitter.com".equalsIgnoreCase(uri.getHost()))) {
            throw new UnsupportedOperationException("Twitter based timeline "
                    + "sources are not yet supported.");
        }

        // SSH
        else if ("ssh".equalsIgnoreCase(uri.getScheme())) {
            throw new UnsupportedOperationException("SSH based timeline sources"
                    + " are not yet supported.");
        }

        // unknown
        else {
            throw new UnsupportedOperationException("Timeline sources for the"
                    + " " + uri.getScheme() + " are not currently supported.");
        }
    }
}
